from rocolib.api.components.Component import Component

c = Component()

#Just printing the top of the car
# c.addSubcomponent("tankskeleton", "FourWheelCar", inherit=True, prefix=None)
# c.addSubcomponent("tophole", "Cutout")
#
# #Connecting tank top
c.addSubcomponent("tanktop", "TankTop", inherit=True, prefix=None)
# c.addSubcomponent("support0", "Rectangle")
# c.addSubcomponent("split0", "SplitEdge")
#
# c.addConstraint(("split0", "toplength"), "width", "(x,)")
# c.addConstraint(("split0", "botlength"), "width", "(float((x - 30)/2.), float(x - (x - 30)), float((x - 30)/2.))")
# c.addConstraint(("support0", "w"),"width", "float(x - (x - 30))")
# c.addConstraint(("support0", "l"), "length", "x*1.5")
#
# c.addConnection(("tankskeleton", "sheath1.topedge0"), ("split0", "topedge0"))
# c.addConnection(("split0", "botedge1"), ("support0", "l"), angle=180)
# c.addConnection(("support0", "r"), ("tanktop", "backedge"), angle=90)

#Attaching the side designs
c.addSubcomponent("side0", "TankSide")
c.addSubcomponent("side1", "TankSide")
c.addSubcomponent("support1", "Trapezoid")
c.addSubcomponent("support2", "Trapezoid")

for i in range(1,3):
    c.addConstraint(("support%d" %i, "width"), "toplength")
    c.addConstraint(("support%d" %i, "depth"), ("width", "topwidth"), "(x[0] - x[1])/2.")
    c.addConstraint(("support%d" %i, "bangle"), ("width", "topwidth", "length", "toplength"),
                    "float(np.atan(((x[0] - x[1])/2.)/((2*x[2]-x[3])/2.))* 180 * 0.318309)") #0.318309 is 1/pi

c.addConstraint(("side0", "length"), "length", "x*2")
c.addConstraint(("side1", "length"), "length", "x*2")

c.addConnection(("tanktop", "ledge"), ("support1", "topedge"), angle=-90)
c.addConnection(("tanktop", "redge"), ("support2", "topedge"), angle=-90)
c.addConnection(("side0", "sideedge"), ("support1", "botedge"))
c.addConnection(("side1", "sideedge"), ("support2", "botedge"))


c.toLibrary("Tank")
